//----------------------------------------------------
//- Landmine By AGlass0fMilk
//- Model and Animation by Muffinmix
//- Version 3
//- Original Landmine made in (I believe) Late 2009
//- Revision date: 8/9/2011
//- It's been a long time...
//----------------------------------------------------

//Changelog:
// -Auto-Environment Detection Added
// -Minigame only explosions
// -Fixed console errors
// -Made loss of limbs less shitty
// -Made it able to spawn on vehicle spawns so you don't have to replace it

datablock PlayerData(LandmineAmputee : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	canRide = 0;
	jumpForce = 500;
	
	maxBackwardCrouchSpeed = 1;
	maxBackwardSpeed = 0;
	maxDamage = 25;
	maxEnergy = 0;
	maxForwardCrouchSpeed = 2;
	maxForwardSpeed = 0;
	maxSideCrouchSpeed = 1;
	maxSideSpeed = 0;
	
	uiName = "";
	
	showEnergyBar = false;
};

datablock WheeledVehicleData(LandmineCol)
{
	isLandmine = true;
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./landMineVehi.dts";
	emap = true;
	minMountDist = 0;
   
   numMountPoints = 0;

	maxDamage = 10;
	destroyedLevel = 10;
	energyPerDamagePoint = 1;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;
	
   // doColorShift = true;
    //colorShiftColor = "0.062745 0.474509 0.000000 1.000000";
	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	//tireEmitter = TireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	



   numWheels = 0;

	// Rigid Body
	mass = 800;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 3;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 0;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 5;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	//splashEmitter[0] = PropaneTankFoamDropletsEmitter;
	//splashEmitter[1] = PropaneTankFoamEmitter;
	//splashEmitter[2] = PropaneTankBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Landmine ";
	rideable = true; //It has no mount points so it isn't rideable, but it needs to be "rideable" in order to appear on the list
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;

   numDmgEmitterAreas = 1;

  initialExplosionProjectile = LandmineFinalExplosionProjectile;
  // initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 100;

   finalExplosionProjectile = "";
   //finalExplosionProjectile = vehicleFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 30;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 1;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};

datablock ItemData(LandmineItem)
{
	category = "Weapon";  // Mission editor category
	classname = "Weapon"; // for inventory

	//equipment = true;

	//its already a member of item namespace so dont break it
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./landMineItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Landmine";
	iconName = "./LandmineIcon";
	doColorShift = false;
	//colorShiftColor = "0.062745 0.474509 0.000000 1.000000";
	
	 // Dynamic properties defined by the scripts
	image = LandmineImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(LandmineImage)
{
   // Basic Item properties
   shapeFile = "./landMineItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0 0 0";
   eyeRotation = eulerToMatrix("0 0 0");
   

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "toolImage";
   ammo = " ";
   // Projectile && Ammo.
   item = LandmineItem;

   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = true;
   
	doColorShift = true;
	colorShiftColor = "0.000000 0.576470 0.0509803 1.000000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;
	stateSequence[0]		= "activate";

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
};
function LandmineImage::onfire(%this, %obj, %slot)
{
	
	
	
	for(%i=0;%i<5;%i++)
	{
		%toolDB = %obj.tool[%i];
		if(%toolDB $= %this.item.getID())
		{
			%obj.tool[%i] = 0;
			%obj.weaponCount--;
			messageClient(%obj.client,'MsgItemPickup','',%i,0);
			serverCmdUnUseTool(%obj.client);
			break;
		}
	}





	%obj.Curtrans = %obj.gettransform();
	%player = %obj.client.player;
	%clientcolor = %obj.client;
	%playertransform = %player.gettransform();
	
	%playervelocity = %obj.getvelocity();

	%vectx = getword(vectorscale(%player.geteyevector(),1.6),0);
	%vecty = getword(vectorscale(%player.geteyevector(),1.6),1);
	%vectz = getword(vectorscale(%player.geteyevector(),1.6),2);

	%startx = getword(%player.gettransform(),0);

	%starty = getword(%player.gettransform(),1);

	%startz = getword(%player.gettransform(),2);

	%startx = %startx + %vectx;
	%starty = %starty + %vecty;
	%startz = %startz +1;




	%obj.client.mine = new WheeledVehicle()
	{

	dataBlock = "LandmineCol";

	};
	
	%mine = %obj.client.mine;
	
	%second= getwords(%player.gettransform(),3,6);
	%mine.setNodeColor("ALL", "0.000000 0.576470 0.0509803 1.000000"); //For some reason vehicles can't color shift
	%mine.setTransform(%startx SPC %starty SPC %startz SPC getwords(%playerTransform,3,6));
	%mine.setvelocity(Vectoradd(vectorscale(%player.getforwardvector(),2),%player.getvelocity()));

	//%mine.setNodeColor("ALL",getColorIDTable(%clientcolor.currentColor));	
//Ok that last part was edited out because of a minigame thing, if you can't paint in a minigame, then all the landmines would be red. You can't change the color of textured parts, so I left this out. I might release both...

	%mine.owner = %obj.client;
	//%thatguy = %obj.client.mine.owner.getcontrolobject();
	
	%mine.spawnBrick = %obj.client; //Obviously, the landmine can't use it's owner as a spawnbrick, thus we make a method called "spawnVehicle" on a client object so it doesn't error in the console
	//The method will do nothing of course, except save the headache of other paths to stop this error
	
	%mine.colorisSet = false;
	%mine.isLandmine = true;
	
	schedule(2000,0,"setLandMine",%mine);
	schedule(250,0,"Checkup",%mine,%player,%obj.client);
        $LandMineData[$LandMineCount++] = %mine;
}

AddDamageType("LandmineExplosion",   '<bitmap:add-ons/Weapon_Landmine/mineExplosion> %1',    '%2 <bitmap:add-ons/Weapon_Landmine/mineExplosion> %1',1,0);
datablock ExplosionData(LandmineFinalExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = gravityRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1.5 1.5 1.5";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 12;
   radiusDamage = 70;

   impulseRadius = 15;
   impulseForce = 2000;

   playerBurnTime = 5000;

};
datablock ProjectileData(LandmineFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
  
   radiusDamageType = $DamageType::LandmineExplosion;
   impactImpulse	   = 1500;
   verticalImpulse	   = 550;
   explosion           = LandmineFinalExplosion;
   particleEmitter     = rocketTrailEmitter;

   brickExplosionRadius = 5;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 60;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 120;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = rocketLoopSound;

   muzzleVelocity      = 120;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 0;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 1;

   uiName = "Landmine";
};

function setLandMine(%mine)
{
	//echo("Landmine active!");
	if(isObject(%mine))
	{
		serverPlay3D(Beep_EKG_Sound, %mine.getTransform());
		%mine.isSet = 1; //Applies the variable to the object so they each have their own variable to set
		//echo(%mine.getID());
	}
}

function LandMine_SB(%spawnbrick) //Mine on a spawnbrick rather than thrown
{
	%client = %spawnbrick.client;
	%mine = %spawnbrick.vehicle;
	%client.mine = %mine;
	%mine.owner = %client;
	
	%mine.colorisSet = true; //Set by Vehicle Spawn
	%mine.isLandmine = true;
	
	schedule(2000,0,"setLandMine",%mine);
	schedule(250,0,"Checkup",%mine, %client.player, %client);
	$LandMineData[$LandMineCount++] = %client.mine;
}

function checkup(%mine,%toucher,%client)
{

    if(!isObject(%mine))
    {
	cancel(%uploop);
	return;
    }
	%start = %mine.getPosition(); //This is the mines position
	%sx = getword(%start,0); // This is the X coordinate
	%sY = getword(%start,1); //This is the Y coordinate
	%sZ = getword(%start,2); //This is the Z coordinate

	%end = %sx SPC %sY SPC %sZ + 2; //This should be little above the landmine

	%check = ContainerRayCast(%start, %end, $TypeMasks::VehicleObjectType, %mine);

	%vehicle = getword(%check,0);

    if(isObject(%mine))
    {
		%uploop = schedule(250,0,"Checkup",%mine,%toucher,%client); //Make it loop if the mine is still there
    }


    if(isObject(%vehicle) && !%vehicle.getDatablock().isLandmine && %mine.isSet == 1)
    {
		%vehicleOwner = %vehicle.spawnBrick.client;
		if(GetMiniGameFromObject(%mine.owner) == GetMiniGameFromObject(%vehicleOwner) && isObject(GetMiniGameFromObject(%mine.owner)))
		{
			%mine.damage(%toucher,%mine.getworldboxcenter(),%mine.getdatablock().maxdamage);
			cancel(%uploop);
		}
    }
}

function Landminecol::Oncollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & $TypeMasks::CorpseObjectType && %obj.isSet == 1)
	{
		%obj.damage(%col,%obj.getworldboxcenter(),%obj.getdatablock().maxdamage);
		%obj.isSet = 0;
	}
	
	if(%col.getType() & $TypeMasks::PlayerObjectType && %obj.isSet == 1)
	{
		if(GetMiniGameFromObject(%obj.owner) == GetMiniGameFromObject(%col.client) && isObject(GetMiniGameFromObject(%obj.owner)))
		{
			if(%col.getClassName() $= "Player")
			{ 
				%obj.damage(%col,%obj.getworldboxcenter(),%obj.getdatablock().maxdamage);
				//Randomized Limb Loss!
				%rand = getRandom(1,5);
				%limbs[1] = "LHand";
				%limbs[2] = "RHand";
				%limbs[3] = "LShoe";
				%limbs[4] = "RShoe";
				if(%rand != 5) //5 means they miraculously didn't lose limbs! (0 occurred too often)
				{
					for(%i=0; %i<%rand; %i++)
					{
						%col.hideNode(%limbs[%rand]);
						if(%rand == 3 || %rand == 4) //If they lost a foot, and didn't already, set to slow
						{
							if(%col.getDataBlock().getName() !$= "LandmineAmputee")
								%col.setDatablock(LandmineAmputee); //Slow Playertype that can only move while crouched (Old crouch thing was stupid)
						}
						%rand = getRandom(1,4);
					}
				}
			}
			
		}
		//%col.brickGroup.client = owner
		else if(%col.getClassName() $= "AIPlayer" && GetMiniGameFromObject(%obj.owner) == GetMiniGameFromObject(%col.brickGroup.client)) //Should work for zombies/horses
			{
				%obj.damage(%col,%obj.getworldboxcenter(),%obj.getdatablock().maxdamage);
				%col.kill(); //Kill the AI Player (Zombie or whatever) stepping on the landmine
			}
		%obj.isSet = 0;
	}
}
//A command to clear them all
function servercmdclearLandmines(%client) //Thanks to Kalphiter for making this part, and saving me the time.
{
   if(%client.isAdmin || %client.isSuperAdmin) //Just to be safe
   {
      for(%a = 0; %a <= $LandMineCount; %a++)
      {
         if(isObject($LandMineData[%a]))//So it doesn't try to delete landmines that got blown up
	 {
            $LandMineData[%a].delete();
         }
      }
      messageAll('msgAdminForce',"\c3"@ %client.getPlayerName() @"\c6 has cleared all landmines");
      $LandMineData[$LandMineCount] = 0;
   }
}

function GameConnection::spawnVehicle(%this, %vehicle)
{
	return 0; //This function does nothing because it is merely to stop errors
	//When a landmine without a spawnbrick (thrown one) tries to respawn, its spawnbrick is set to its owner's client, thus this function is called
	//Nothing happens, no errors occur
}

//Package when spawning landmine on a vehicle spawn
package LandMinePackage
{
	function fxDTSBrick::spawnVehicle(%this, %vehicle)
	{
		if(%this.vehicleDatablock.isLandmine) //if spawning vehicle is a landmine
		{
			%result = parent::spawnVehicle(%this, %vehicle);
			LandMine_SB(%this);
		}
		else
		{
			%result = parent::spawnVehicle(%this, %vehicle);
		}
		return %result;
	}
	
	//Thanks to Vehicle Rampage Mod for idea, can't remember name of person who made it
	function LandmineCol::onImpact(%db,%mine,%col,%pos,%speed)
	{
		//Collision didn't detect bricks for some odd reason, so we have to search for 'em!
		if(!%mine.colorisSet) //if color isn't set
		{
			initContainerBoxSearch(%mine.getWorldBoxCenter(), "3 3 3", $TypeMasks::FxBrickObjectType);
			while(%brick = containerSearchNext())
			{
				if(isObject(%brick))
				{
					//echo(getColorIDTable(%brick.getColorID()));
					//echo(%brick.getID());
					%color = getColorIDTable(%brick.getColorID());
					%mine.setNodeColor("ALL", getWords(%color, 0, 2) SPC "1.0"); //Trans is always 1.0
					%mine.colorisSet = true;
					break;
				}
			}
		}
	}
	
	function servercmdResetMinigame(%client)
	{
		if(GetMiniGameFromObject(%client).owner == %client) //if client owns minigame
		{
			for(%a = 0; %a <= $LandMineCount; %a++)
			{
				if(isObject($LandMineData[%a]) && GetMiniGameFromObject($LandMineData[%a].owner) == GetMiniGameFromObject(%client))//So it doesn't try to delete landmines that got blown up
				{
					$LandMineData[%a].delete();
				}
			}
		}
		return Parent::servercmdResetMinigame(%client);
	}
	
	function servercmdEndMinigame(%client)
	{
		if(GetMiniGameFromObject(%client).owner == %client) //if client owns minigame
		{
			for(%a = 0; %a <= $LandMineCount; %a++)
			{
				if(isObject($LandMineData[%a]) && GetMiniGameFromObject($LandMineData[%a].owner) == GetMiniGameFromObject(%client))//So it doesn't try to delete landmines that got blown up
				{
					$LandMineData[%a].delete();
				}
			}
		}
		return Parent::servercmdEndMinigame(%client);
	}
};
activatePackage(LandMinePackage);